# IRsUnknownJoint Interface Reference

Inherits IUnknown.

List of all members.

## Public Member Functions
HRESULT | GetBone1 ([out, retval] IRsNode **pBoneNode)
HRESULT | GetBone2 ([out, retval] IRsNode **pBoneNode)
HRESULT | InvalidateBones ()
HRESULT | GetJointPosition ([out, retval] RtPoint *pPosition)
HRESULT | SetJointTransform ([in] IRdMatrixf *pTransform)
HRESULT | GetReferencePosition ([out, retval] RtPoint *pTransform)
HRESULT | SetReferencePosition ([in] RtPoint *pTransform)
HRESULT | InvalidateFkPose ()
HRESULT | GetJointId (GUID *pgId)
HRESULT | SetJointId (GUID *pgId)

## Detailed Description

IRsUnknownJoint is an interface to Skeleton bone.

## Member Function Documentation

HRESULT IRsUnknownJoint::GetBone1 | ( | [out, retval] IRsNode ** | pBoneNode | ) |

Get bone1 node.

Returns:
  pBoneNode [out,retval] Returns bone1 node.

HRESULT IRsUnknownJoint::GetBone2 | ( | [out, retval] IRsNode ** | pBoneNode | ) |

Get bone2 node.

Returns:
  pBoneNode [out,retval] Returns bone2 node.

HRESULT IRsUnknownJoint::InvalidateBones | ( |  | ) |

Invalidate bones.

HRESULT IRsUnknownJoint::GetJointPosition | ( | [out, retval] RtPoint * | pPosition | ) |

Get joint position in Skeleton space.

Returns:
  pPosition [out,retval] Returns joint position.

HRESULT IRsUnknownJoint::SetJointTransform | ( | [in] IRdMatrixf * | pTransform | ) |

Set joint bone1->bone2 transform matrix. Reference matrix is also set.

Parameters:

  | pTransform | [in] Transform or joint.

HRESULT IRsUnknownJoint::GetReferencePosition | ( | [out, retval] RtPoint * | pTransform | ) |

Get joint reference position. Used for invalidation optimizations.

Returns:
  pTransform [out,retval] Returns joint reference position.

HRESULT IRsUnknownJoint::SetReferencePosition | ( | [in] RtPoint * | pTransform | ) |

Set joint reference position.

Parameters:

  | pTransform | [in] Reference position for joint.

HRESULT IRsUnknownJoint::InvalidateFkPose | ( |  | ) |

Invalidate FK pose which causes recalculation of matrices when needed.

HRESULT IRsUnknownJoint::GetJointId | ( | GUID * | pgId | ) |

Get joint ID.

Returns:
  pgId [out,retval] Joint ID.

HRESULT IRsUnknownJoint::SetJointId | ( | GUID * | pgId | ) |

Set joint ID.

Parameters:

  | pgId | [in] ID to set joint to.